<?php

if (!function_exists('sv') || preg_match('#plugins/countvisits/index.php#i', $_SERVER['SCRIPT_NAME'])){die('no direct access');}

/*
============================================================
CMSimple Plugin CountVisits
============================================================
Version:    CountVisits 2.2
Released:   2024-01
Copyright:  Gert Ebersbach - www.ge-webdesign.de
============================================================ 
License:
- free for noncommercial websites
- fee required for commercial websites
============================================================ 
utf-8 check: äöü 
*/

if(!isset($_SESSION))
{
	session_set_cookie_params(7200);
	session_start();
}


/*
##########################################################
         Besucherzähler / Visitors Counter
##########################################################
*/


function countvisits_rrmdir($dir)
{
	if (is_dir($dir))
	{
		$objects = scandir($dir);
		foreach ($objects as $object)
		{
			if ($object != "." && $object != "..") 
			{
				if (filetype($dir."/".$object) == "dir") countvisits_rrmdir($dir."/".$object); else unlink($dir."/".$object);
			}
		}
		reset($objects);
		rmdir($dir);
	}
}



// deletes automatic more then 1 year old backup folders 

if(is_dir('./backups/countvisits/' . (date('Y')-2)) == true && $plugin_cf['countvisits']['delete_old_backups'] == 'true')
{
	$countvisits_deletePath = './backups/countvisits/' . (date('Y')-2);
	countvisits_rrmdir($countvisits_deletePath);
}

// for old datapath (countvisits 2.0 and lower)
if(is_dir($plugin_cf['countvisits']['data_path'] . (date('Y')-2)) == true && $plugin_cf['countvisits']['delete_old_backups'] == 'true')
{
	$countvisits_deletePath = $plugin_cf['countvisits']['data_path'] . (date('Y')-2);
	countvisits_rrmdir($countvisits_deletePath);
}


function countvisitsV($cvFileName='cvNoName')
{
	global $adm, $pth, $plugin_cf, $plugin_tx;
	
	if(!defined('CMSIMPLE_VERSION')){return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';}
	
	
	// exclude robots
	if(preg_match('/robot|robo|bot|spider|spyder|crawler|crawl|curl|sniffer|sniff|Googlebot|Google|^$/i', $_SERVER['HTTP_USER_AGENT']) && $plugin_cf['countvisits']['robots_exclude'] == 'true'){return;}
	
	// Datei erzeugen, wenn nicht vorhanden
	if(!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt'))
	{
		$cvCreateFile = fopen($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt',"w+");
		fwrite($cvCreateFile, '1');
		fclose($cvCreateFile);
		chmod($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt',0666);
	}
	
	// aktuellen Zählerstand feststellen
	$counterCurrent = file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt');
	
	// neuen Zählerstand schreiben
	if
	(
		!isset($_SESSION[$cvFileName]) && 
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '_lock.txt') && 
		!$adm && !isset($_GET['login']) && 
		!isset($_GET['logout']) &&  
		$counterCurrent !== false &&
		$counterCurrent !== '' && 
		$counterCurrent > 0
	)
	{
		$counterLock = fopen($plugin_cf['countvisits']['data_path'] . $cvFileName . '_lock.txt',"w+");
		fwrite($counterLock, 'locked');
		fclose($counterLock);
		
		$writeCounter = fopen($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt',"w+");
		
		if($counterCurrent == ""){$counterCurrent = '0';}
	
		$counterCurrent++;
		fwrite($writeCounter, $counterCurrent);
		$_SESSION[$cvFileName] = true;
		fclose($writeCounter);
		unlink($plugin_cf['countvisits']['data_path'] . $cvFileName . '_lock.txt');
	}
}


/*
##########################################################
     Seitenaufrufe Zähler / Page Impressions Counter
##########################################################
*/

function countvisitsPI($cvFileName='cvNoName')
{
	global $adm, $pth, $plugin_cf, $plugin_tx;
	
	if(!defined('CMSIMPLE_VERSION')){return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';}
	
	// exclude robots
	if(preg_match('/robot|robo|bot|spider|spyder|crawler|crawl|curl|sniffer|sniff|Googlebot|Google|^$/i', $_SERVER['HTTP_USER_AGENT']) && $plugin_cf['countvisits']['robots_exclude'] == 'true'){return;}
	
	// Datei erzeugen, wenn nicht vorhanden
	if(!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt'))
	{
		$cvCreateFile = fopen($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt',"w+");
		fwrite($cvCreateFile, '1');
		fclose($cvCreateFile);
		chmod($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt',0666);
	}
	
	// aktuellen Zählerstand feststellen
	$counterCurrent = file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt');
	
	// neuen Zählerstand schreiben
	if
	(
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '_lockPI.txt') && 
		!$adm && !isset($_GET['login']) && 
		!isset($_GET['logout']) && 
		$counterCurrent !== false &&
		$counterCurrent !== '' && 
		$counterCurrent > 0
	)
	{
		$counterLock = fopen($plugin_cf['countvisits']['data_path'] . $cvFileName . '_lockPI.txt',"w+");
		fwrite($counterLock, 'locked');
		fclose($counterLock);
		
		$writeCounter = fopen($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt',"w+");
		
		if($counterCurrent == ""){$counterCurrent = '0';}
	
		$counterCurrent++;
		fwrite($writeCounter, $counterCurrent);
		fclose($writeCounter);
		unlink($plugin_cf['countvisits']['data_path'] . $cvFileName . '_lockPI.txt');
	}
}


/*
##########################################################
     Verhältnis / relation
##########################################################
*/

function countvisitsREL($cvFileName='cvNoName')
{
	global $plugin_cf, $plugin_tx;
	
	if(!defined('CMSIMPLE_VERSION')){return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';}
	
	if
	(
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') || 
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') == '' || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') == ''
	)
	{
		return '<p><b>CountVisits Plugin:</b><br>One or both data files missing or empty</p>';
	}
	
	if(file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') && file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt'))
	{
		$countvisits = file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt');
		$countvisitsPI = file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt');
		$relVisitsPI = '<div class="cvoutputREL"><span class="cvCounterREL">' . number_format($countvisitsPI / $countvisits,'2',$plugin_tx['countvisits']['numbers_delimiter'],$plugin_tx['countvisits']['numbers_thousands_delimiter']) . '</span> <span class="cvTextREL">' . $plugin_tx['countvisits']['text_relation'] . '</span></div>' . "\n";
		return $relVisitsPI;
	}
}


/*
##########################################################
                  Ausgabe / Output
##########################################################
*/

function countvisits($cvFileName='cvAllNoName',$cvAdminMode='no')
{
	global $adm, $plugin_tx, $plugin_cf;
	
	if(!defined('CMSIMPLE_VERSION')){return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';}
	
	if(!is_writable($plugin_cf['countvisits']['data_path']))
	{
		$cvnwrt = '<p><b>CountVisits Plugin:</b>' . tag('br') . $plugin_tx['countvisits']['hint_datapath_not_writable'] . '</p>';
		return $cvnwrt;
	}
	
	// deletes configured folder (plugin configuration)
	if($plugin_cf['countvisits']['delete_data_folder'] != '')
	{
		$countvisits_deletePath = './backups/countvisits/' . $plugin_cf['countvisits']['delete_data_folder'];
		countvisits_rrmdir($countvisits_deletePath);
	}
	
// B A C K U P datafiles
	
	if($plugin_cf['countvisits']['data_create_backups'] == 'true')
	{
		if(!is_dir('./backups/'))
		{
			mkdir('./backups/', 0777, true);
			chmod('./backups/', 0777);
		}
		
		if(!is_dir('./backups/countvisits/'))
		{
			mkdir('./backups/countvisits/', 0777, true);
			chmod('./backups/countvisits/', 0777);
		}
		
		// create folders (filename) 
		if(!is_dir('./backups/countvisits/' . date('Y') . '/' . $cvFileName))
		{
			mkdir('./backups/countvisits/' . date('Y') . '/' . $cvFileName, 0777, true);
			chmod('./backups/countvisits/' . date('Y'), 0777);
			chmod('./backups/countvisits/' . date('Y') . '/' . $cvFileName, 0777);
		}
		
		// create backup files
		if(!file_exists('./backups/countvisits/' . date('Y') . '/' . $cvFileName . '/' . date('Ymd') . '_' . $cvFileName . '.txt'))
		{
			copy($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt', './backups/countvisits/' . date('Y') . '/' . $cvFileName . '/' . date('Ymd') . '_' . $cvFileName . '.txt');
			chmod('./backups/countvisits/' . date('Y') . '/' . $cvFileName . '/' . date('Ymd') . '_' . $cvFileName . '.txt', 0666);
		}
		
		if(!file_exists('./backups/countvisits/' . date('Y') . '/' . $cvFileName . '/' . date('Ymd') . '_' . $cvFileName . '_PI.txt'))
		{
			copy($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt', './backups/countvisits/' . date('Y') . '/' . $cvFileName . '/' . date('Ymd') . '_' . $cvFileName . '_PI.txt');
			chmod('./backups/countvisits/' . date('Y') . '/' . $cvFileName . '/' . date('Ymd') . '_' . $cvFileName . '_PI.txt', 0666);
		}
	}

	if(function_exists('countvisitsV')){countvisitsV($cvFileName);}
	if(function_exists('countvisitsPI')){countvisitsPI($cvFileName);}

	if
	(
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') || 
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') == '' || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') == ''
	)
	{
		return '<p><b>CountVisits Plugin:</b><br>One or both data files missing or empty</p>';
	}

	$cvOutputBefore = '<div class="cvoutputContainer">' . "\n";
	$cvOutput = '<div class="cvoutputV"><span class="cvCounterV">' . number_format(file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt'),'0',$plugin_tx['countvisits']['numbers_delimiter'],$plugin_tx['countvisits']['numbers_thousands_delimiter']) . '</span> <span class="cvTextV">' . $plugin_tx['countvisits']['text_visitors'] . '</span></div>' . "\n";
	$cvOutputPI = '<div class="cvoutputPI"><span class="cvCounterPI">' . number_format(file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt'),'0',$plugin_tx['countvisits']['numbers_delimiter'],$plugin_tx['countvisits']['numbers_thousands_delimiter']) . '</span> <span class="cvTextPI">' . $plugin_tx['countvisits']['text_page_impressions'] . '</span></div>' . "\n";
	$cvOutputREL = countvisitsREL($cvFileName);
	$cvOutputBehind = '</div>' . "\n";
	
	if($cvAdminMode == 'adminmode')
	{
		if($adm)
		{
			return $cvOutputBefore . $cvOutput . $cvOutputPI . $cvOutputREL . $cvOutputBehind;
		}
		else
		{
			return '';
		}
	}
	elseif($cvAdminMode == 'adminmode_vp')
	{
		if($adm)
		{
			return $cvOutputBefore . $cvOutput . $cvOutputPI . $cvOutputREL . $cvOutputBehind;
		}
		else
		{
			return $cvOutputBefore . $cvOutput . $cvOutputBehind;
		}
	}
	else
	{
		return $cvOutputBefore . $cvOutput . $cvOutputPI . $cvOutputREL . $cvOutputBehind;
	}
}


/*
##########################################################
  Ausgabe einzeln ohne Zähler / Output single no counter
##########################################################
*/

// Show visitors
function cvShowV($cvFileName='cvNoName',$cvTextV='cvNoName',$cvTextPos='before')
{
	global $adm, $plugin_tx, $plugin_cf;
	
	if(!defined('CMSIMPLE_VERSION')){return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';}
	
	if(!is_writable($plugin_cf['countvisits']['data_path']))
	{
		$cvnwrt = '<p><b>CountVisits Plugin:</b>' . tag('br') . $plugin_tx['countvisits']['hint_datapath_not_writable'] . '</p>';
		return $cvnwrt;
	}
	
	if
	(
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') || 
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') == '' || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') == ''
	)
	{
		return '<p><b>CountVisits Plugin:</b><br>One or both data files missing or empty</p>';
	}
	
	$cvOutputBefore = '<div class="cvShowVisitorsContainer">' . "\n";
	
	if($cvTextPos == 'before')
	{
		$cvOutput = '<div class="cvShowVisitorsContainerIn"><span class="cvTextShowV">' . $cvTextV . '</span> <span class="cvNumberShowV">' . number_format(file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt'),'0',$plugin_tx['countvisits']['numbers_delimiter'],$plugin_tx['countvisits']['numbers_thousands_delimiter']) . '</span></div>' . "\n";
	}
	else
	{
		$cvOutput = '<div class="cvShowVisitorsContainerIn cvShowTextAfter"><span class="cvNumberShowV">' . number_format(file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt'),'0',$plugin_tx['countvisits']['numbers_delimiter'],$plugin_tx['countvisits']['numbers_thousands_delimiter']) . '</span> <span class="cvTextShowV">' . $cvTextV . '</span></div>' . "\n";
	}
	
	$cvOutputBehind = '</div>' . "\n";
	
	return $cvOutputBefore . $cvOutput . $cvOutputBehind;
}

// Show pageviews
function cvShowPI($cvFileName='cvNoName',$cvTextPI='cvNoName',$cvTextPos='before')
{
	global $adm, $plugin_tx, $plugin_cf;
	
	if(!defined('CMSIMPLE_VERSION')){return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';}
	
	if(!is_writable($plugin_cf['countvisits']['data_path']))
	{
		$cvnwrt = '<p><b>CountVisits Plugin:</b>' . tag('br') . $plugin_tx['countvisits']['hint_datapath_not_writable'] . '</p>';
		return $cvnwrt;
	}
	
	if
	(
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') || 
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') == '' || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') == ''
	)
	{
		return '<p><b>CountVisits Plugin:</b><br>One or both data files missing or empty</p>';
	}
	
	$cvOutputBefore = '<div class="cvShowPageviewsContainer">' . "\n";
	
	if($cvTextPos == 'before')
	{
		$cvOutput = '<div class="cvShowPageviewsContainerIn"><span class="cvTextShowPI">' . $cvTextPI . '</span> <span class="cvNumberShowPI">' . number_format(file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt'),'0',$plugin_tx['countvisits']['numbers_delimiter'],$plugin_tx['countvisits']['numbers_thousands_delimiter']) . '</span></div>' . "\n";
	}
	else
	{
		$cvOutput = '<div class="cvShowPageviewsContainerIn cvShowTextAfter"><span class="cvNumberShowPI">' . number_format(file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt'),'0',$plugin_tx['countvisits']['numbers_delimiter'],$plugin_tx['countvisits']['numbers_thousands_delimiter']) . '</span> <span class="cvTextShowPI">' . $cvTextPI . '</span></div>' . "\n";
	}
	
	$cvOutputBehind = '</div>' . "\n";
	
	return $cvOutputBefore . $cvOutput . $cvOutputBehind;
}


// Show relation
function cvShowREL($cvFileName='cvNoName',$cvTextREL='cvNoName',$cvTextPos='before')
{
	global $adm, $plugin_tx, $plugin_cf;
	
	if(!defined('CMSIMPLE_VERSION')){return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';}
	
	if(!is_writable($plugin_cf['countvisits']['data_path']))
	{
		$cvnwrt = '<p><b>CountVisits Plugin:</b>' . tag('br') . $plugin_tx['countvisits']['hint_datapath_not_writable'] . '</p>';
		return $cvnwrt;
	}
	
	if
	(
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') || 
		!file_exists($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt') == '' || 
		file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt') == ''
	)
	{
		return '<p><b>CountVisits Plugin:</b><br>One or both data files missing or empty</p>';
	}
	
	$showCountvisits = file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '.txt');
	$showCountvisitsPI = file_get_contents($plugin_cf['countvisits']['data_path'] . $cvFileName . '_PI.txt');
	
	$cvOutputBefore = '<div class="cvShowRelationContainer">' . "\n";
	
	if($cvTextPos == 'before')
	{
		$cvOutput = '<div class="cvShowRelationContainerIn"><span class="cvTextShowREL">' . $cvTextREL . '</span> <span class="cvNumberShowREL">' . number_format($showCountvisitsPI / $showCountvisits,'2',$plugin_tx['countvisits']['numbers_delimiter'],$plugin_tx['countvisits']['numbers_thousands_delimiter']) . '</span></div>' . "\n";
	}
	else
	{
		$cvOutput = '<div class="cvShowRelationContainerIn cvShowTextAfter"><span class="cvNumberShowREL">' . number_format($showCountvisitsPI / $showCountvisits,'2',$plugin_tx['countvisits']['numbers_delimiter'],$plugin_tx['countvisits']['numbers_thousands_delimiter']) . '</span> <span class="cvTextShowREL">' . $cvTextREL . '</span></div>' . "\n";
	}
	
	$cvOutputBehind = '</div>' . "\n";
	
	return $cvOutputBefore . $cvOutput . $cvOutputBehind;
}

?>